【Codeforces Round 332 (Div 2)C】【贪心】Day at the Beach 最多区间数划分使得区间排序构成全局排序

来源:互联网 发布:php权限源码 编辑:程序博客网 时间:2024/06/10 08:01
C. Day at the Beach
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

One day Squidward, Spongebob and Patrick decided to go to the beach. Unfortunately, the weather was bad, so the friends were unable to ride waves. However, they decided to spent their time building sand castles.

At the end of the day there were n castles built by friends. Castles are numbered from 1 to n, and the height of the i-th castle is equal tohi. When friends were about to leave, Squidward noticed, that castles are not ordered by their height, and this looks ugly. Now friends are going to reorder the castles in a way to obtain that condition hi ≤ hi + 1 holds for all i from 1 to n - 1.

Squidward suggested the following process of sorting castles:

  • Castles are split into blocks — groups of consecutive castles. Therefore the block from i to j will include castles i, i + 1, ..., j. A block may consist of a single castle.
  • The partitioning is chosen in such a way that every castle is a part of exactly one block.
  • Each block is sorted independently from other blocks, that is the sequence hi, hi + 1, ..., hj becomes sorted.
  • The partitioning should satisfy the condition that after each block is sorted, the sequence hi becomes sorted too. This may always be achieved by saying that the whole sequence is a single block.

Even Patrick understands that increasing the number of blocks in partitioning will ease the sorting process. Now friends ask you to count the maximum possible number of blocks in a partitioning that satisfies all the above requirements.

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 100 000) — the number of castles Spongebob, Patrick and Squidward made from sand during the day.

The next line contains n integers hi (1 ≤ hi ≤ 109). The i-th of these integers corresponds to the height of the i-th castle.

Output

Print the maximum possible number of blocks in a valid partitioning.

Sample test(s)
input
31 2 3
output
3
input
42 1 3 2
output
2
Note

In the first sample the partitioning looks like that: [1][2][3].

In the second sample the partitioning is: [2, 1][3, 2]


#include<stdio.h>#include<iostream>#include<string.h>#include<string>#include<ctype.h>#include<math.h>#include<set>#include<map>#include<vector>#include<queue>#include<bitset>#include<algorithm>#include<time.h>using namespace std;void fre(){freopen("c://test//input.in","r",stdin);freopen("c://test//output.out","w",stdout);}#define MS(x,y) memset(x,y,sizeof(x))#define MC(x,y) memcpy(x,y,sizeof(x))#define MP(x,y) make_pair(x,y)#define ls o<<1#define rs o<<1|1typedef long long LL;typedef unsigned long long UL;typedef unsigned int UI;template <class T1,class T2>inline void gmax(T1 &a,T2 b){if(b>a)a=b;}template <class T1,class T2>inline void gmin(T1 &a,T2 b){if(b<a)a=b;}const int N=1e5+10,M=0,Z=1e9+7,ms63=1061109567;int casenum,casei;int n;struct A{int v,p;bool operator < (const A& b)const{if(v!=b.v)return v<b.v;else return p<b.p;}}a[N];int p[N];int main(){while(~scanf("%d",&n)){for(int i=1;i<=n;++i){scanf("%d",&a[i].v);a[i].p=i;}sort(a+1,a+n+1);a[0].v=0;for(int i=1;i<=n;++i)p[a[i].p]=i;int i=1; int rgt=1;int ans=0;while(i<=n){while(i<=rgt)gmax(rgt,p[i++]);++ans;++rgt;}printf("%d\n",ans);}return 0;}/*【trick&&吐槽】【题意】给你n(1e5)个数,每个数的取值范围是[1,1e9]。让你对这n个数,划分为尽可能多的区间。使得——每个区间内的数做升序排序后,整体的所有数也是升序的。【类型】贪心【分析】这道题很有趣呀~~首先,这道题,必然是有解的。因为最坏情况下,我们也可以只划分为一个区间,然后必定是满足要求的。我们发现,如果我们按照从左到右的顺序思考问题——那么,每次划分一个区间,总的右界划分到了r的话,肯定是恰好包含了[1,r]中所有应该有的数。什么叫[1,r]中应该有的数呢?我们可以一开始把所有数按照(数值,位置)这个双关键字做排序。然后,排序到的位置,就是如果要把这个数划分到合适的区间,至少需要划分到的r位置。接下来,我们一直扫描,扫描到恰好使得——"前p位置的数就包含了这前p个数"。这样就贪心做划分就好啦。很显然,"能划分就立刻划分"是基于贪心原则的最优做法。这道题就这样AC喽!【时间复杂度&&优化】O(nlogn)*/


0 0
原创粉丝点击